#ifndef USGDINT_H
#define USGDINT_H

/* Functions declared in this header:

   int_remove() - remove last installed interrupt
   int_clean() - remove all installed interrupts (except TSRs)
   int_install(char* function) - install interrupt routine at given
   address
      NOTE: since Small-C doesn't support pointers to functions, this
      must be handled specially. Such as this:

extern char MyIntRoutine_TAG[];

asm("MyIntRoutine_TAG:\n");
MyIntRoutine() {
   // Your code goes here
   // make it quick!
}

main() {
   clrscr;
   int_install(MyIntRoutine_TAG);
   ...
}

*/

intrpt_install(func) char* func; {
#asm
   ld  hl,2
   add hl,sp
   call LD_HL_MHL
   call INT_INSTALL
#endasm
}

intrpt_remove() {
   asm("\tcall INT_REMOVE\n");
}

intrpt_clean() {
   asm("\tcall INT_CLEAN\n");
}

#endif

