#ifndef __PIXEL_C
#define __PIXEL_C

#include <findpix.h>

/* Small C library, by Chris Dannemiller (dannemiller@hotmail.com)
   http://www.geocities.com/SiliconValley/Vista/1143

   Synopsis:
      pixel(x,y,c)

   Description:
      This function draws a pixel at the (x,y) coordinate with the the
      specified drawing mode

   Example:
      pixel(0,0,PT_ON)
      pixel(5,5,PT_CHG)
      pixel(foo,bar,PT_XOR)

   Notes:
      o See TIxx.H for desciption of the PT_* macros
      o This function could be made faster!

*/

pixel(x,y,c) char x, y, c; {
#asm
	ld	hl,2
	add	hl,sp
	ld	a,(hl)

	inc	hl
	inc	hl
        ld      d,(hl)

	inc	hl
	inc	hl
        ld      e,(hl)

	; a = Color
	; e = x
	; d = y
_drawpix:
	and	a
	jr	z,_delpix
	dec	a
	jr	z,_putpix
	dec	a 
	jr	z,_chgpix
	ret
_putpix:
	call	FindPixel
        or      (hl)
        ld      (hl),a
	ret
_delpix:
	call	FindPixel
	cpl
        and     (hl)
        ld      (hl),a
	ret
_chgpix:
	call    FindPixel
        xor     (hl)
        ld      (hl),a
#endasm
}
#endif
