;
; Small C runtime for multiplication, division, switch
;
;

#ifdef inc_mult
; HL = DE * HL [signed]
_mul: ld b,h
	ld	c,l
        ld hl,0
_mul1:   ld a,c
	rrca
        jr nc,_mul2
	add	hl,de
_mul2:   xor   a
	ld	a,b
	rra
	ld	b,a
	ld	a,c
	rra
	ld	c,a
	or	b
	ret	z
	xor	a
	ld	a,e
	rla
	ld	e,a
	ld	a,d
	rla
	ld	d,a
	or	e
	ret	z
        jr _mul1
#endif
#ifdef inc_div

; HL = DE / HL, DE = DE % HL
_div: ld b,h
	ld	c,l
	ld	a,d
	xor	b
	push	af
R_crt20: call  m,_deneg
	ld	a,b
	or	a
R_crt21: call  m,_bcneg
   ld a,16
	push	af
	ex	de,hl
   ld de,0
_div1:   add   hl,hl
; {DE <r<r 1}
_rdel:   ld a,e
	rla
	ld	e,a
	ld	a,d
	rla
	ld	d,a
	or	e
   jr z,_div2
; {BC : DE}
_cmpbd: ld  a,e
	sub	c
	ld	a,d
	sbc	a,b
R_crt22: jp m,_div2
	ld	a,l
   or 1
	ld	l,a
	ld	a,e
	sub	c
	ld	e,a
	ld	a,d
	sbc	a,b
	ld	d,a
_div2:   pop   af
	dec	a
        jr z,_div3
	push	af
        jr _div1
_div3:   pop   af
	ret	p
R_crt23: call _deneg
	ex	de,hl
R_crt24: call _deneg
	ex	de,hl
	ret
; {DE = -DE}
_deneg: ld  a,d
	cpl
	ld	d,a
	ld	a,e
	cpl
	ld	e,a
	inc	de
	ret
; {BC = -BC}
_bcneg: ld  a,b
	cpl
	ld	b,a
	ld	a,c
	cpl
	ld	c,a
	inc	bc
	ret
#endif
#ifdef inc_case
; case jump
_case:   ex de,hl       ;switch value to DE
	pop	hl		;get table address
_case1:
R_crt25: call _case4      ;get case value
	ld	a,e
	cp	c		;equal to switch value .
        jr nz,_case2   ;no
	ld	a,d
	cp	b		;equal to switch value .
        jr nz,_case2   ;no
R_crt26: call _case4      ;get case label
        jr z,_case3 ;end of table, go to default
        ld hl,(PROGRAM_ADDR)    ; ZShell modification
        add hl,bc
        push  hl
	ret			;case jump
_case2:
R_crt27: call _case4      ;get case label
        jr nz,_case1   ;next case
_case3:  dec   hl
	dec	hl
	dec	hl
	ld	d,(hl)
	dec	hl
	ld	e,(hl)
	ex	de,hl
                           ; ZShell modification
        ld bc,(PROGRAM_ADDR)    ; bc contains no useful info (I think)
        add hl,bc
        jp   (hl)            ;default jump
_case4:  ld c,(hl)
	inc	hl
	ld	b,(hl)
	inc	hl
	ld	a,c
	or	b
	ret
#endif
