/* TechWareZ v1.0 source code (GPL) - Dape/Istar 1997
 *
 * The whole source is actually one big mess, don't consider it as an
 * example of good programming style.. This is what happens when you
 * try to write c-programs at the same time you're still writing the
 * low level asm routines for the compiler.. there are all kinds of
 * workarounds for several bugs which exist no more ;)
 * For example all variables are global and most of parameter passing
 * between functions is done by using those variables. This isn't
 * necessary anymore, but this method is actually better, I think,
 * because it saves some space. Accessing local variables and function
 * parameters is slow and produces a lot of code..
 *
 * The comments & other stuff are mostly in finnish and I'm too lazy
 * translate them. Don't even ask.
 */

/* Maaston mitat.. MAASTO_KORKEUS on maaston maksimikorkeus, MAASTO_Y 
  maksimi scrollauskorkeus (?) */

#define MAASTO_X 256
#define MAASTO_KORKEUS 80
#define MAASTO_Y 112

/* Scrollauksen maara pikseleina/funktiokutsu (vain ylos/alas-suunnassa) */
#define STEP 4

/* Statusbarin korkeus */
#define STATUS_HEIGHT 8

/* Heiton tarkkuus.. tai siis fixed pointin */
#define PR 5

/* Pelaajien tankkien maarat */
#define PLAYERS 2
#define TANKS_PER_PLAYER 4
#define TOTAL_TANKS (PLAYERS*TANKS_PER_PLAYER)
#define PLAYER_MASK 0x03
#define MASK_ALLTANKS 0x07

/* Ovela makro tankin omistajan selvittamiseksi tankkinumeron perusteella.. */
#define TANK_OWNER(x) (x>>2)

/* Pelaajatyypit */
#define TI      0
#define HUMAN   1

/* Aseiden maara */
#define WEAPON_COUNT 5

/* Maasto */
unsigned char maasto[MAASTO_X] @ GRAPH_MEM;

/* Lista kaikista tankeista */
struct {
  int health;
  int x;
  int y;
  int xd;
  int yd;
  unsigned char weapon;
  char ammo[WEAPON_COUNT];
  char name[4];
  } tanks[TOTAL_TANKS] @ GRAPH_MEM+MAASTO_X;

#define TANKS_SIZE (TOTAL_TANKS*20) /* = sizeof(tanks) */

char players[2] @ GRAPH_MEM+MAASTO_X+TANKS_SIZE;
char plr_turn[2] @ GRAPH_MEM+MAASTO_X+TANKS_SIZE+2;

/* Aselista */
struct {
  char name[5];
  char range;
  char gravity;
  char wind;
  char number;
  unsigned int time;
  char delay;
  } weapons[WEAPON_COUNT] = {
    { "BAZK", 5, 1, 1, 1, 700, 4 },
    { "GRND", 6, 1, 0, 1, 700, 4 },
    { "SGUN", 4, 0, 0, 1, 400, 0 },
    { "MGUN", 3, 0, 0, 10, 100, 0 },
    { "NUKE", 12, 1, 1, 1, 1000, 5 }
    };

/* Muuttujat.. aikajarjestyksessa kayton mukaan.. temppimuuttujia kaytetaan
  paallekkain jonkin verran.. eli sillisalaattia, ala yritakaan ymmartaa */
int i @ TEXT_MEM;
int j @ TEXT_MEM+2;
int k @ TEXT_MEM+4;
int l @ TEXT_MEM+6;
int m @ TEXT_MEM+8;
int n @ TEXT_MEM+10;
int osuma @ TEXT_MEM+12;
int x @ TEXT_MEM+14;
int y @ TEXT_MEM+16;
int xd @ TEXT_MEM+18;
int yd @ TEXT_MEM+20;
int gravity @ TEXT_MEM+22;
int wind @ TEXT_MEM+24;
int quit @ TEXT_MEM+26;

int pln @ TEXT_MEM+28;
int o @ TEXT_MEM+30;
int p @ TEXT_MEM+32;
int q @ TEXT_MEM+34;
int xd2 @ TEXT_MEM+36;
int yd2 @ TEXT_MEM+38;
int yp @ TEXT_MEM+40;
int xp @ TEXT_MEM+42;
int time @ TEXT_MEM+44;
int range @ TEXT_MEM+46;
int ammo_delay @ TEXT_MEM+48;
int scroll_x @ TEXT_MEM+50;
int scroll_y @ TEXT_MEM+52;
int sc_i @ TEXT_MEM+54;
int sc_j @ TEXT_MEM+56;
int sc_k @ TEXT_MEM+58;
int sc_l @ TEXT_MEM+60;
int sc_m @ TEXT_MEM+62;
/*char temppi[4] @ TEXT_MEM+64;*/
int tmp_a @ TEXT_MEM+68;
int tmp_b @ TEXT_MEM+70;
int scr_a @ TEXT_MEM+72;
int scr_b @ TEXT_MEM+74;
int wk_i @ TEXT_MEM+76;
int tank_count[2] @ TEXT_MEM+78;

#define clr_scr() clrscr()

/* Tarpeellisia prototyyppeja */
void scroll_up();
void scroll_down();
void scroll_right();
void scroll_left();

/* A wait routine.. waits t/200 seconds or until keypress */
unsigned char wait_key(int t) {
  wk_i = t;
  do {
#asm
  halt
#endasm
  } while((!kbhit()) && (--wk_i));
  return wk_i;
}

/* Paivittaa vaakarivin ruudulla maaston mukaiseksi */
void paivita_rivi() {
  for(sc_i = 0; sc_i < 128; sc_i++) {
    sc_k = maasto[sc_i+scroll_x]-scroll_y+STATUS_HEIGHT;
    if(sc_j<sc_k)
      pixel_on(sc_i,sc_j);
    else
      pixel_off(sc_i,sc_j);
    }
}

/* Tarkistaa onko koordinaatti nayton sisalla */
int is_visible() {
  return ((tmp_a > 0)&&(tmp_a<128)&&(tmp_b>STATUS_HEIGHT)&&(tmp_b<64));
}

/**** Naytto/piirtorutiinit ****/

/* Piirtaa hienon "pallon".. tata kaytetaan seka tahtayskursorina etta 
  ammuksena */
void pallo() {
  tmp_a = xp-=scroll_x;
  tmp_b = yp-=scroll_y-STATUS_HEIGHT;
  if(is_visible()) {
    pixel_change(xp,yp);
    pixel_change(xp,yp+1);
    pixel_change(xp,yp-1);
    pixel_change(xp+1,yp);
    pixel_change(xp-1,yp);
    }
}

/* Hardkoodattuja spritej. Uh-oh. */
void piirra_tankit() {
  for(sc_k = 0; sc_k < TOTAL_TANKS; sc_k++) {
    if(tanks[sc_k].health > 0) {
      tmp_a = sc_l = tanks[sc_k].x-scroll_x;
      tmp_b = sc_m = tanks[sc_k].y-scroll_y+STATUS_HEIGHT;
      if(is_visible()) {
        pixel_on(sc_l,sc_m);
        pixel_on(sc_l,++sc_m);
        pixel_on(sc_l,++sc_m);
        pixel_on(sc_l+1,sc_m);
        pixel_on(sc_l-1,sc_m);
        }
      }
    }
}

/* Piirtaa nimen ja healthin tankin paalle (?) */
void piirra_health() {
/* Set menu text to XOR.. (temporarily) */
#asm
  ld hl,$834B
  set 3,(hl)
#endasm

  for(sc_k = 0; sc_k < TOTAL_TANKS; sc_k++) {
    if(tanks[sc_k].health > 0) {
      tmp_a = sc_l = tanks[sc_k].x-scroll_x;
      tmp_b = sc_m = tanks[sc_k].y-scroll_y+STATUS_HEIGHT;
      if(is_visible()) {
        wk_i = (sc_l-4)+((63-sc_m-20)<<8);
        goto_xym(wk_i);
        printsm(tanks[sc_k].name);
        goto_xym(wk_i+0x0600-0x000A);
        printdm(tanks[sc_k].health);
        }
      }
    }

#asm
  ld hl,$834B
  res 3,(hl)
#endasm
}


/* Pyorea rajahdysanimaatio paikkaan (x,y), range=sade */
void Poks() {
  k = 0;
  n = range+range;
  p = range*range;
  do {
    rand();
    i = (randseed1%n)-range;
    j = (randseed2%n)-range;
    if(((i*i)+(j*j))<p) { /* ..hidasta, mutta tekee kivan ympyrn.. */
      tmp_a = i+=x-scroll_x;
      tmp_b = j+=y-scroll_y+STATUS_HEIGHT;
      if(is_visible()) {
        pixel_change(i,j);
        }
      }
  } while((!(m=kbhit()))&&(++k<time));
  if(m==K_EXIT) m = 1;
    else m = 0;
}

/* Tyhjentaa status barin */
void clear_status() {
  for(scr_a = 0; scr_a < STATUS_HEIGHT; scr_a++) {
    scr_b = -(scr_a*16);
#asm
  ld a,0
  ld b,16
  ld hl,(_scr_b)
clear_status_l0:
  ld (hl),a
  dec hl
  djnz clear_status_l0
#endasm
    }
}

/* Paivittaa status barin tiedot */
void piirra_status() {
  clear_status();
  goto_xym(0x3800);
  printsm(tanks[pln].name);
  printdm(tanks[pln].health);
  l = tanks[pln].ammo[tanks[pln].weapon];
  if(l == -1) {
    printsm("           ");
    }
  else {
    printdm(l);
    printsm("*");
    }
  printsm(weapons[tanks[pln].weapon].name);
  xp = 96+(4*wind);
  if(wind > 0) { 
    for(yp = 96; yp <= xp; yp++) {
      pixel_on(yp,3);
      pixel_on(yp,4);
      }
    pixel_on(--xp,5);
    pixel_on(xp,2);
    }
  else
  if(wind < 0) {
    for(yp = xp; yp <= 96; yp++) {
      pixel_on(yp,3);
      pixel_on(yp,4);
      }
    pixel_on(++xp,5);
    pixel_on(xp,2);
  }
  else
  if(wind==0) {
    pixel_on(96,3);
    pixel_on(96,4);
    pixel_on(97,3);
    pixel_on(97,4);
    }
}

/* Nayttaa stringin status barissa */
void show_status(char* s) {
  clear_status();
  goto_xym(0x3800);
  printsm(s);
}

/* Paivittaa pystyrivin ruudulla maaston mukaiseksi */
void paivita_maasto_horz() {
  if(sc_k < 0) sc_k = 0;
  if(sc_k > 127) sc_k = 127;
  if(sc_l < 0) sc_l = 0;
  if(sc_l > 127) sc_l = 127;
  for(sc_i = sc_k; sc_i <= sc_l; sc_i++) {
    sc_k = maasto[sc_i+scroll_x]-scroll_y+STATUS_HEIGHT;
    if(sc_k<0) sc_k = 0;
    if(sc_k>64) sc_k = 64;
    for(sc_j = STATUS_HEIGHT; sc_j < sc_k; sc_j++)
      pixel_on(sc_i,sc_j);
    for(sc_j = sc_k; sc_j < 64; sc_j++)
      pixel_off(sc_i,sc_j);
    }
}

/* Enemman tai vahemman satunnainen maastogeneraattori */
void tee_maasto() {
  maasto[0] = (rand()&0x1f)+(rand()&0x1f);
  for(i = 1; i < MAASTO_X; i++) {
    j=maasto[i-1]+(rand()&0x0f)-(rand()&0x0f);
    if(j>MAASTO_KORKEUS) j = MAASTO_KORKEUS;
    if(j<0) j = 0;
    maasto[i] = j;
    }
  /* Eroosio iskee */
  l = (rand()&0x0f)+2;
  for(k = 0; k < l; k++)
    for(i = 1; i < MAASTO_X-1; i++) {
      maasto[i] = ((int)(maasto[i-1] + maasto[i] + maasto[i+1] + maasto[i]))>>2;
      }
}

/* Pudottaa tankit maaston korkeudelle */
void pudota_tankit() {
  for(o = 0; o < TOTAL_TANKS; o++)
    tanks[o].y = maasto[tanks[o].x]+2;
}

/* Pt alas */
void ammu() {
  x=x<<PR;
  y=y<<PR;
  yd2=yd;
  xd2=xd;
  osuma = 0;
  do {
    piirra_tankit();
    xp = i = x>>PR;
    yp = j = y>>PR;
  
  if(q == 0) {
      if(i < (scroll_x+16))
        scroll_left();
      if(i > (scroll_x+112))
        scroll_right();
      if(j < (scroll_y+16))
        scroll_down();
      if(j > (scroll_y+64-16-STATUS_HEIGHT))
        scroll_up();
      }
    pallo(/*i,j*/);
    
    yd2+=gravity;
    xd2+=wind;
    x+=(xd2>>(1+7-PR));
    y+=(yd2>>(1+7-PR));

    if(kbhit()==K_EXIT) osuma = 3;
    
    if(x < 0) osuma = 2;
    if(x > (MAASTO_X*(1<<PR))) osuma = 2;
    if(y > (2*MAASTO_Y*(1<<PR))) osuma = 2;

    if(!osuma) {
      /* Tarkistetaan osumat maastoon */
      if(y <= ((maasto[x>>PR])<<PR))
        osuma = 1;
      /* Tarkistetaan osumat tankkeihin.. jotka voi optimoida laatikoiksi */
      /* Tama ei kylla nayta toimivan jostakin syysta */
      for(k = 0; k < TOTAL_TANKS; k++)
        if((abs(x-tanks[k].x)<4)&&(abs(y-tanks[k].y)<5))
          osuma = 1;
      }

    delay(ammo_delay);
    xp = i; yp = j;
    pallo();
  } while(!osuma);
  x=x>>PR;
  y=y>>PR;
}

void scroll_to() {
  do {
  i = scroll_x; j = scroll_y;
  if(x < (scroll_x+48))
    scroll_left();
  if(x > (scroll_x+80))
    scroll_right();
  if(y < (scroll_y+24))
    scroll_down();
  if(y > (scroll_y+64-24-STATUS_HEIGHT))
    scroll_up();
  piirra_tankit();
  } while((i!=scroll_x)||(j!=scroll_y));
}

/* Suojautukaa, pommi-attentaatti koordinaateissa (x,y)! */
int rajayta() {
  Poks();

/* .. sitten tehdn todellista vahinkoa.. */
  o = (2*range)+1;
  p++;
    
  for(i = 0; i < o; i++) {
    j = x-range+i;
    if((j >= 0)&&(j < MAASTO_X)) {
      k = y-((n=sqrt8(p-(i-range)*(i-range))>>7)>>1);
      if(k<0) k=0;
      if((l = maasto[j]) > k) {
        if(l > (k+n)) {
          if(l > n) {
            maasto[j]=l-n;
            }
          else {
            maasto[j]=0;
            }
          }
        else {
          maasto[j] = k;
         }
        }   
      }
    }

/* Pudotetaan tankkeja ja paivitetaan ruutua jos se on tarpeellista */
  pudota_tankit();
  sc_k = x-range-scroll_x; sc_l = x+range-scroll_x;
  paivita_maasto_horz();
  piirra_tankit();

  return m;
}

/* Tarkistaa osumat tankkeihin.. */
int tarkista_osumat() {
  o = range*range;
  for(k = 0; k < TOTAL_TANKS; k++) {
    if(tanks[k].health>0) {
      i = x-tanks[k].x; 
      j = y-tanks[k].y;
      m = (i*i)+(j*j);
      if(m<o) {
        tanks[k].health-=3*(o/((m>>2)+1));
        if(tanks[k].health<0)
          tank_count[TANK_OWNER(k)]--;
        }
      }
    }
}

/* Artificial Intelligence Service.. sometimes this works *too* well! */
void make_move() {
  piirra_tankit();
  piirra_health();
  /* Pick yer weapon randomly */
  do {
    i = tanks[pln].weapon = ((unsigned int)rand())%(unsigned int)(WEAPON_COUNT);
  } while(tanks[pln].ammo[i]==0);

  if(tanks[pln].ammo[i]>0)
    tanks[pln].ammo[i]--;

  /* Check if wind/gravity correction is necessary */
  if(weapons[i].wind==0) j = 0;
    else j = wind;

  if(weapons[i].gravity==0) k = 0;
    else k = gravity;

  /* Select the target.. */
  while(tanks[TANKS_PER_PLAYER*(!TANK_OWNER(pln))+l].health<=0) l++;
  
  l = rand()&PLAYER_MASK;
  while(tanks[TANKS_PER_PLAYER*(!TANK_OWNER(pln))+l].health<=0) 
    l = (l+1)&PLAYER_MASK;
  l += TANKS_PER_PLAYER*(!TANK_OWNER(pln));

  /* Select a random flight time */
  i = ((abs(tanks[pln].x - tanks[l].x))/32)+(rand()&0x03)+1;
  
  /* And calculate the initial velocity for x- and y- coordinates */
  xd = (tanks[l].x-tanks[pln].x)*16;
  
  xd = (xd/i)-8*i*j;

  yd = (tanks[l].y-tanks[pln].y-2)*16;
  if(yd>0)
    yd = (yd/i)-8*i*k;
  else
    yd = -((-yd)/i)-8*i*k;
  piirra_status();
  wait_key(150);
  piirra_health();
}

/* Kysyy kayttajan siirtoa.. */
int get_user_input() {
  j = tanks[pln].x+tanks[pln].xd;
  k = tanks[pln].y+tanks[pln].yd;
  
  do {
    piirra_status();
    piirra_tankit();
    piirra_health();
    xp = j;
    yp = k;
    pallo();
    i = getch();
    xp = j;
    yp = k;
    pallo();
    piirra_health();
    switch(i) {
      case K_UP    : k++;
                     break;
      case K_DOWN  : k--;
                     break;
      case K_LEFT  : j--;
                     break;
      case K_RIGHT : j++;
                     break;
      case K_F1    : tanks[pln].weapon = 0;
                     break;
      case K_F2    : tanks[pln].weapon = 1;
                     break;
      case K_F3    : tanks[pln].weapon = 2;
                     break;
      case K_F4    : tanks[pln].weapon = 3;
                     break;
      case K_F5    : tanks[pln].weapon = 4;
                     break;
      case K_8     : scroll_up();
                     break;
      case K_2     : scroll_down();
                     break;
      case K_6     : scroll_right();
                     break;
      case K_4     : scroll_left();
                     break;
      case K_EXIT  : break;
      default : i = -1;
      }
  if((i==-1)&&(tanks[pln].ammo[tanks[pln].weapon]==0)) {
    show_status("-- No ammo! --");
    wait_key(300);
    i = -2;
    }
  } while((i!=K_EXIT)&&(i!=-1));
  if(tanks[pln].ammo[tanks[pln].weapon]>0)
    tanks[pln].ammo[tanks[pln].weapon]--;

  xd = (tanks[pln].xd=(j-tanks[pln].x))*32;
  yd = (tanks[pln].yd=(k-tanks[pln].y))*32;
                                            
  return (i==K_EXIT);
}

void playgame() {
  clr_scr();
  
  quit = 0;
  pln = 0;
  sc_k = 0; sc_l = 127;
  paivita_maasto_horz();

  do {
    wind = (rand()&0x7)-4;
    gravity = -8;

    piirra_status();
    
    x = tanks[pln].x;
    y = tanks[pln].y;
    scroll_to();
    if(players[TANK_OWNER(pln)]==TI)
      make_move();
    else
      if(get_user_input()) quit = 1;
    
    if(!quit) {
      if(!weapons[tanks[pln].weapon].gravity) gravity = 0;
      if(!weapons[tanks[pln].weapon].wind) wind = 0;
      for(q = 0; (q < weapons[tanks[pln].weapon].number)&&(!quit); q++) {
        x = tanks[pln].x;
        y = tanks[pln].y;
        ammo_delay = weapons[tanks[pln].weapon].delay;
        ammu();
        switch(osuma) {
          case 1 : range = weapons[tanks[pln].weapon].range;
                   time = weapons[tanks[pln].weapon].time;
                   tarkista_osumat();
                   if(rajayta())
                     quit = 1; 
                   break;
          
          case 2 : show_status("-- Out of screen! --"); 
                   if(wait_key(20))
                     quit = 1;
                   break;
          
          case 3 : show_status("-- Aborting game --"); 
                   wait_key(90);
                   quit = 1;
                   break;
          }
        }
      if(wait_key(60))
        quit = 1;
      
      if((!tank_count[0])&&(tank_count[1])) {
        show_status("-- Game Over : Player B won! --");
        wait_key(1000);
        quit = 1;
        }
      else
        if((!tank_count[1])&&(tank_count[0])) {
          show_status("-- Game Over : Player A won! --");
          wait_key(1000);
          quit = 1;
          }
        else if((!tank_count[0])&&(!tank_count[1])) {
          show_status("-- Game Over : It's a tie! --");
          wait_key(1000);
          quit = 1;
          }

  if(!quit) {
      if(TANK_OWNER(pln)==0)
        pln = TANKS_PER_PLAYER;
      else 
        pln = 0;

      i=plr_turn[TANK_OWNER(pln)];
      do {
        i=(i+1)&PLAYER_MASK;
      } while(tanks[i+pln].health<=0);
      plr_turn[TANK_OWNER(pln)] = i;
      pln+=i;
    }
    }
  } while(!quit);
}

int askgame() {
  clr_scr();
  goto_xy(0x0100);
  prints("TechWareZ v1.0 Final");
  goto_xym(0x0A24);
  printsm("(c) Istar 1997");
  goto_xy(0x0003);
  prints("F1 : Human vs. Human");
  goto_xy(0x0004);
  prints("F2 : Human vs. TI");
  goto_xy(0x0005);
  prints("F3 : TI vs. TI (demo)");
  goto_xy(0x0006);
  prints("F5 : Quit");
  quit = 0;
  while(!quit) {
    switch(getch()) {
      case K_F1   : players[0] = HUMAN;
                    players[1] = HUMAN;
                    quit = 1;
                    break;
      case K_F2   : players[0] = HUMAN;
                    players[1] = TI;
                    quit = 1;
                    break;
      case K_F3   : players[0] = TI;
                    players[1] = TI;
                    quit = 1;
                    break;
      case K_EXIT :
      case K_F5   : quit = 2;
      }
    }
  return (quit==2)?0:1;
}

/* Nayton scrollausrutiinit.. */
void scroll_right() {
  if(scroll_x>(MAASTO_X-128-8)) return;
  scroll_x+=8;
#asm
  ld b,64-STATUS_HEIGHT
  ld hl,$FC01
scroll_right_l0:
  push bc
  ld b,15
scroll_right_l1:
  ld a,(hl)
  dec hl
  ld (hl),a
  inc hl
  inc hl
  djnz scroll_right_l1
  inc hl
  pop bc
  djnz scroll_right_l0
#endasm
  sc_k = 120; sc_l = 127;
  paivita_maasto_horz(/*120,127*/);
}

void scroll_left() {
  if(scroll_x<8) return;
  scroll_x-=8;
  sc_i = 0xFFFE-16*STATUS_HEIGHT;
#asm
  ld b,64-STATUS_HEIGHT
  ld hl,(_sc_i)
scroll_left_l0:
  push bc
  ld b,15
scroll_left_l1:
  ld a,(hl)
  inc hl
  ld (hl),a
  dec hl
  dec hl
  djnz scroll_left_l1
  dec hl
  pop bc
  djnz scroll_left_l0
#endasm
  sc_k = 0; sc_l = 7;
  paivita_maasto_horz(/*0,7*/);
}

void scroll_down() {
  if(scroll_y<STEP) return;
  scroll_y-=STEP;
  sc_i = STEP*16;
  sc_k = 64-STATUS_HEIGHT-STEP;
#asm
  ld b,16
  ld hl,$FC00
  ld de,(_sc_i)
scroll_down_l0:
  push bc
  ld a,(_sc_k)
  ld b,a
scroll_down_l1:
  add hl,de
  ld a,(hl)
  or a
  sbc hl,de
  ld (hl),a
  inc hl
  djnz scroll_down_l1
  pop bc
  djnz scroll_down_l0
#endasm
  for(sc_l = 0; sc_l < STEP; sc_l++) {
    sc_j = STATUS_HEIGHT+sc_l;
    paivita_rivi();
    }
}

void scroll_up() {
  if(scroll_y>(MAASTO_Y-64-STEP)) return;
  scroll_y+=STEP;
  sc_i = STEP*16;
  sc_j = 0xFFFF-STATUS_HEIGHT*16;
  sc_k = 64-STATUS_HEIGHT-STEP;
#asm
  ld b,16
  ld hl,(_sc_j)
  ld de,(_sc_i)
scroll_up_l0:
  push bc
  ld a,(_sc_k)
  ld b,a
scroll_up_l1:
  or a
  sbc hl,de
  ld a,(hl)
  add hl,de
  ld (hl),a
  dec hl
  djnz scroll_up_l1
  pop bc
  djnz scroll_up_l0
#endasm
  for(sc_l = 63-STEP; sc_l < 64; sc_l++) {
    sc_j = sc_l;
    paivita_rivi(/*63-sc_l*/);
    }
}

/* Paalooppi.. ei turhan mutkikas. */
void main() {
  scroll_x=scroll_y=0;
  while(askgame()) {
    tee_maasto();
  
    for(i=0;i<TOTAL_TANKS;i++) {
      tanks[i].x = rand()&0xff;
      tanks[i].xd = tanks[i].weapon = 0;
      tanks[i].yd = 10;
      tanks[i].health = 100;
      tanks[i].ammo[0] = -1;
      tanks[i].ammo[1] = 5;
      tanks[i].ammo[2] = 3;
      tanks[i].ammo[3] = 2;
      tanks[i].ammo[4] = 1;
      if(i < TANKS_PER_PLAYER)
        tanks[i].name[0] = 'A';
      else
        tanks[i].name[0] = 'B';
      tanks[i].name[1] = '1'+(i&PLAYER_MASK);
      tanks[i].name[2] = 0;
    }
  
    tank_count[0] = tank_count[1] = 4;
    plr_turn[0] = 0;
    plr_turn[1] = -1; /* This is not a bug, this is a feature ;) */
  
    pudota_tankit();
    playgame();
    }
}
