#name "Tic-Tac-Toe Demo"

#include "usglib.h"
#include "lib\tabline.c"
#include "lib\sprite_x.c"
#include "lib\rand.c"

#define true 1
#define false 0

/* Sprites - actual data at end of file */
extern char tic_x[8], tic_o[8], square[8];
extern char point[];
char brd[9];

main() {
   char res;

   clrscr;
   graphpage();
   tabline("Tic-Tac-Toe");
   /* Print my name */
   _menu_x = 70;
   puts_m("by Jeremy Dewey");

   /* Draw board */
   hline(10,45,21);
   hline(10,45,34);
   vline(10,45,21);
   vline(10,45,34);

   /* Draw message window */
   hline(70,126,0);
   vline(0,54,69);
   vline(0,54,127);

   /* Populate message window */
   setxy_m(90,9);
   puts_m("Your  move");
   setxy_m(90,16);
   puts_m("CPU's move");

   res = playgame();
   setxy_m(85,23);
   if (res == 0) puts_m("Cat won!");
   else if (res == 1) puts_m("You won!");
   else puts_m("CPU won!");
   getkey();
}

playgame() {
   char count;
   count = 0;
   do {
      human();
      if (winner()) return 1;
      if (++count == 5) return 0; /* Board is full */
      cpu();
      if (winner()) return 2;
   } while (true);
}

cpu() {
   char i;

   setxy_m(75,16);
   puts_m(point);

   while (1) {
      for(i=0;i<9;i++)
         if (!brd[i] && rand() < 5000) {
            brd[i] = 2;
            draw(tic_o,i%3,i/3);
            _menu_x = 75;
            puts_m(point);
            return;
         }
   }
}

human() {
   char x,y,c,index,done;
   x = done = 0;
   y = 2;

   setxy_m(75,9);
   puts_m(point);
   do {
      draw(square,x,y);
      c = getkey();
      draw(square,x,y);
      if (c == K_UP) {
         if (y < 2) y++;
         else y = 0;
      } else if (c == K_DOWN) {
         if (y > 0) y--;
         else y = 2;
      } else if (c == K_LEFT) {
         if (x > 0) x--;
         else x = 2;
      } else if (c == K_RIGHT) {
         if (x < 2) x++;
         else x = 0;
      } else if (c == K_EXIT)
         _exit();
      else if (c == K_SECOND) {
         index = x+y*3;
         if (!brd[index]) done = 1;
         brd[index] = 1;
      }
   } while (!done);
   draw(tic_x,x,y);
   _menu_x = 75;
   puts_m(point);
}

winner() {
   if (verify(0,1,2)) return 1;
   if (verify(3,4,5)) return 2;
   if (verify(6,7,8)) return 3;
   if (verify(0,3,6)) return 4;
   if (verify(1,4,7)) return 5;
   if (verify(2,5,8)) return 6;
   if (verify(0,4,8)) return 7;
   if (verify(2,4,6)) return 8;
   return false;
}

verify(a,b,c) char a,b,c; {
   char chk;

   chk = brd[a] + (brd[b] << 2) +  (brd[c] << 4);
   if (chk == 21 || chk == 42) return true;
   return false;
}

draw(spr, x, y) char* spr; char x,y; {
   sprite_x(spr,11+13*x,11+13*y,8,8);
}

/* Sprite data */
#asm
tic_x:
.db %11000011
.db %11100111
.db %01111110
.db %00111100
.db %00111100
.db %01111110
.db %11100111
.db %11000011
tic_o:
.db %00111100
.db %01111110
.db %11100111
.db %11000011
.db %11000011
.db %11100111
.db %01111110
.db %00111100
square:
.db %01010101
.db %10101010
.db %01010101
.db %10101010
.db %01010101
.db %10101010
.db %01010101
.db %10101010

.db %00100100
.db %01001001
.db %10010010
.db %00100100
.db %01001001
.db %10010010
.db %00100100
.db %01001001
#endasm

/* Hide String (defined here because of special character
   You can use the char.c (a sample program) to find the numbers of
   other special characters */
#asm
point:
.db 5,5,5,0
#endasm

